//----------------------------------------------------------------------//
// NyanFi																//
//  ACR擾Xbh												//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include "Global.h"
#include "icon_thread.h"
#include "AppDlg.h"

#pragma package(smart_init)

//---------------------------------------------------------------------------
//Xbh̏
//---------------------------------------------------------------------------
__fastcall TGetIconThread::TGetIconThread(bool CreateSuspended) : TThread(CreateSuspended)
{
	Priority		= tpLower;
	FreeOnTerminate = true;

	CallbackWnd 	= NULL;
}

//---------------------------------------------------------------------------
//擾̒ʒm
//---------------------------------------------------------------------------
void __fastcall TGetIconThread::IconNotify()
{
	//t@C[
	if (CallbackWnd)
		::SendMessage(CallbackWnd, WM_NYANFI_FLICON, (WPARAM)0, (LPARAM)0);

	//`[
	if (AppListDlg && AppListDlg->Visible)
		::SendMessage(AppListDlg->Handle, WM_NYANFI_FLICON, (WPARAM)0, (LPARAM)0);
}

//---------------------------------------------------------------------------
void __fastcall TGetIconThread::Execute()
{
	while (!Terminated) {
		//
		IconRWLock->BeginWrite();
		while (CachedIcoList->Count>IconCache) {
			delete (TIcon*)CachedIcoList->Objects[0];
			CachedIcoList->Delete(0);
		}
		IconRWLock->EndWrite();

		//擾
		int last_cnt = GetTickCount();
		int cnt = 0;

		for (int i=0; !Terminated && i<CachedIcoList->Count; i++) {
			if (CachedIcoList->Objects[i]) continue;

			UnicodeString fnam = CachedIcoList->Strings[i];

			HICON hIcon;
			SHFILEINFO sif;
			if (::SHGetFileInfo(fnam.c_str(), 0, &sif, sizeof(SHFILEINFO), SHGFI_ICON|SHGFI_SMALLICON))
				hIcon = sif.hIcon;
			else
				hIcon = get_fext_icon(get_extension(fnam));

			TIcon *icon  = new TIcon();
			icon->Handle = hIcon;
			CachedIcoList->Objects[i] = (TObject*)icon;
			cnt ++;

			if (((int)GetTickCount() - last_cnt) > 200) {	//***
				IconNotify();
				last_cnt = GetTickCount();
				cnt = 0;
			}
		}

		if (cnt>0) IconNotify();

		Sleep(50);
	}
}
//---------------------------------------------------------------------------
